# mypy-boto3-eks

[![PyPI - mypy-boto3-eks](https://img.shields.io/pypi/v/mypy-boto3-eks.svg?color=blue)](https://pypi.org/project/mypy-boto3-eks)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-eks.svg?color=blue)](https://pypi.org/project/mypy-boto3-eks)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)

- [mypy-boto3-eks](#mypy-boto3-eks)
  - [How to use](#how-to-use)
  - [Automated type discovery](#automated-type-discovery)


Type annotations for
[boto3.EKS 1.13.24](https://boto3.amazonaws.com/v1/documentation/api/1.13.24/reference/services/eks.html#EKS) service
compatible with [mypy](https://github.com/python/mypy), [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/) and other tools.

Generated by [mypy-boto3-buider 2.0.2](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

- [mypy-boto3-eks](#mypy-boto3-eks)
  - [How to use](#how-to-use)
    - [Type checking](#type-checking)
  - [How it works](#how-it-works)

## How to use

Make sure you have [mypy](https://github.com/python/mypy) installed and activated in your IDE.

Install `boto3-stubs` for `EKS` service.

```bash
python -m pip install boto3-stubs[eks]

# update installed packages index for automated type discovery
python -m mypy_boto3
```

Use `boto3` with `mypy_boto3_eks` in your project and enjoy type checking and auto-complete.

```python
import boto3

from mypy_boto3_eks import EKSClient

# Now mypy can check if your code is valid.
client: EKSClient = boto3.client("eks")

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: EKSClient = session.client("eks")



# Waiters are also supported

import mypy_boto3_eks.waiter as eks_waiters

cluster_active_waiter: eks_waiters.ClusterActiveWaiter = client.get_waiter("cluster_active")
cluster_deleted_waiter: eks_waiters.ClusterDeletedWaiter = client.get_waiter("cluster_deleted")
nodegroup_active_waiter: eks_waiters.NodegroupActiveWaiter = client.get_waiter("nodegroup_active")
nodegroup_deleted_waiter: eks_waiters.NodegroupDeletedWaiter = client.get_waiter("nodegroup_deleted")


# Annotated paginators are included as well

import mypy_boto3_eks.paginator as eks_paginators

list_clusters_paginator: eks_paginators.ListClustersPaginator = client.get_paginator("list_clusters")
list_fargate_profiles_paginator: eks_paginators.ListFargateProfilesPaginator = client.get_paginator("list_fargate_profiles")
list_nodegroups_paginator: eks_paginators.ListNodegroupsPaginator = client.get_paginator("list_nodegroups")
list_updates_paginator: eks_paginators.ListUpdatesPaginator = client.get_paginator("list_updates")
```

## Automated type discovery

`mypy_boto3` package can generate index for `mypy_boto3_eks` and other installed services.

```bash
# Run this command when you add or remove service packages
python -m mypy_boto3
```

Generated index provides overloads for `boto3.client` and `boto3.service`,
`boto3.Session.client` and `boto3.Session.resource` functions,
so explicit type annotations are not needed.

- `mypy` supports function overloads as expected
- `PyCharm` also supports function overloads, but consumes a lot of RAM, use carefully
- `VSCode` does not currently support function overloads

Also, generated index allows you to import types from `mypy_boto3`:

```python
# you can replace imports
import mypy_boto3_eks as eks
from mypy_boto3_eks import EKSClient

# with these
from mypy_boto3 import eks
from mypy_boto3.eks import EKSClient
```